#!/usr/bin/python
#
# (c) Max Kresch, licensed under BSD, 2008.
#     See LICENSE for further details. 


import numpy
nar = numpy.add.reduce
import cPickle as cp

Tol = 1e-10

S = []

S.append( numpy.matrix([[1,0,0],[0,0,-1],[0,1,0]]) )
S.append( numpy.matrix([[0,0,1],[0,1,0],[-1,0,0]]) )
S.append( numpy.matrix([[-1,0,0],[0,1,0],[0,0,1]]) )

currentLength = 0
while len(S) != currentLength:
  currentLength = len(S)
  candidates = []
  for i in S:
    for j in S:
      candidates.append( i*j )
  for i in candidates:
    addit = True
    for j in S:
      if nar(nar( (numpy.array(i - j))**2 )) < Tol :
        addit = False
    if addit:
      S.append(i)

cp.dump(S,open("S.pkl",'w'))

