#!/usr/bin/python
#
# (c) Max Kresch, licensed under BSD, 2008.
#     See LICENSE for further details. 


import numpy

def doit( S ):
  N = S.shape[0]
  A = S.T
  B = numpy.array( numpy.matrix(S).getI() )
  M = numpy.zeros( (N*N,N*N) )
  for i in range(N):
    for j in range(N):
      for k in range(N):
        M[two2one(N,i,j),two2one(N,k,j)] += A[i,k]
        M[two2one(N,i,j),two2one(N,i,k)] -= B[k,j]
  return M

def two2one(N,i,j):
  return N*i + j
